# How to contribute

The FOME project is always looking for new contributors, so thanks for your interest!

## Submitting changes

Create a [GitHub Pull Request](https://github.com/FOME-Tech/fome-fw/compare) with your changes to have it reviewed by the maintainers.

Be descriptive in the description and your commit messages about what the PR does. The more information and context, the better. Referencing GitHub issues and pull requests is great.

Each pull request should be atomic: include the minimum set of changes to go from one working configuration to another. If you want to fix multiple bugs or add multiple features, split them up for one PR per distinct issue.

### Testing

All PRs must pass CI gates (should see a ✅ next to the last commit) to be merged. Many builds are run (firmware for all boards, unit tests, etc) and need to all be passing before something is merged. You should of course test yourself instead of being surprised with an ❌ next to your build!

<!--## Contribution Licensing

Note that all contributions to the project are made under the Github Contributor Lincensing Agreement: https://cla.github.com/agreement This ensures that all contributions made to the project are licensed in the same way as the existing work. Such an agreement is not intended to deprive contributors of their copyright, but to protect the project from claims by malicious contributors.-->
