# TunerStudio (TS)

This directory contains the initialization and configuration files for the
rusEFI interface to TunerStudio.

The primary contents are a set ```rusefi*.ini``` initialization files, used to
configure TunerStudio to setup and monitor a specific ECU board.  These are
the only files a typical end user needs.

The ```translations``` directory contains non-English-language translations
for TunerStudio.

In TunerStudio some fields have little question mark on the left of the name for additional field tips.
Those tips are defined in `../integration/rusefi_config.txt`

The initialization files are automatically generated from a combination
of input files located both in this directory and in the board-specific
directories .

```rusefi*.ini``` files are generated based on the following four inputs:
1) ```rusefi_config.txt``` contains configuration region definition in proprietary text format.
2) ```rusefi.input``` contains the UI - all the menus and dialogs. UI definition starts at ```menuDialog = main```
line - here you will see all top level menus defined with internal IDs and visible text labels.
3) ```mapping.yaml``` is a minor detail related to how pins are named in drop downs
4) ```prepend.txt``` is a minor detail which allows you to hide elements of the UI using ```@@if_XXX``` syntax.


The combined file is generated by ConfigDefinition.jar tool.
On Windows this may be run with ```gen_config.bat```.


Q: how do I offer my changes to TS project?

A: please PR only source files (rusefi.input & rusefi_config.txt). Once merged, gen_config.bat would be executed automatically and results would be pushed by automation.
